###########//// Start of User-Defined Variables Section \\\\############

############################## File Locking ############################

# Does your system have file locking ('flock')?  This stops your data 
# files getting corrupted when to different users try to save to the 
# same file simultaneously.  If it does, change the following value to
# 1, e.g. $lockit = 1;. If you're on a Windows server, set it to 0.

$lockit = 0;

##################### Location of Programs #############################

# Path to mail program.
# Examples: 
# $mailprog = '/usr/bin/sendmail';
# $mailprog = '/usr/sbin/sendmail';

$mailprog = '/usr/lib/sendmail';

# Full URL of this script  :
$cgi_url = 'http://tigertom.com/cgi-bin/omni/omni.cgi';

# (Absolute) path to template text file to send in the email to the customer :
# In this example, the file is not in the same directory as the 
# script:  $email_text = '/user/tigertom/web/html/myemail.txt'.
# Here, we assume it IS in the same directory as the script:

$email_text = 'myemail.txt';

# (Absolute) path to data file to store all form data.
# In this example, the file is not in the same directory as the 
# script:  $datafile = '/user/tigertom/web/html/datafile.dat'.
# Here, we assume it's in the same directory as the script:

$save_file = 'datafile.dat';

# Delimiter (entry separation symbol) to be used to QUERY the databases.
# The one used here, '|', is called a "pipe".  A comma, or
# two colons can also be used.  Don't change it unless you really
# need to. Remove the \\ if you are using another symbol. This may cause
# errors.

$DELIM = "\\|";

# Delimiter (entry separation symbol) to be used to SAVE TO the databases.
# The one used here, '|', is called a "pipe".  A comma, or
# two colons can also be used.  Don't change it unless you really
# need to.

$DELIM2 = "|"; 

########################### Valid Referers #################################

# List the URL that is allowed to call this script, 
# to stop other sites calling it.  Leave this blank if other
# sites (like affiliates), or unsubscribers-from-emails are calling
# this script.
# Note: NO trailing forward-slash here:

@valid_urls = ('www.tigertom.com','66.33.65.177','tigertom.com');

############################ String Length / Text Wrapping ###################

# At greater than what length should the script consider wrapping text input?  
# [Set this to a larger number if you don't want the script to mess with 
# long form input field strings.]

$string_limit = '100';

# And at what length should it start to wrap the text?

$wrap_at = '65';

###################### Final Pages to display / URL's to pass data to #######

# Do you want this script to ask the customer to confirm the data
# sent to it? If you set this scalar to "1", the customer can check
# what they wrote before it's processed.  
# Set it to "0", for simple forms. 
# IMPORTANT: Set it to "0", if you are bulk-emailing with the form.

$confirm_input = '1';

### Only set ONE of the next three options will work, if you set
### them, and in the order you set them i.e. the next option will take
### precedence over the following one.

# Full URL of directory where you are keeping files to re-direct browser
# to download. (NO trailing foward-slash here!), e.g.:
# $download_url = 'http://www.tigertom.com/download';

$download_url = 'http://www.tigertom.com/download';

# Leave this latter option blank, unless you want the want the last output of the
# script to be a re-direction to a file specified in the HTML of 'omni.html', like
# this:
#
# <INPUT TYPE=RADIO NAME="download" VALUE="">
# <INPUT TYPE=RADIO NAME="download" VALUE="bookerxt.exe">
# <INPUT TYPE=RADIO NAME="download" VALUE="bookgdxt.exe">
#
############################
### URL of second Perl SCRIPT that the tigertom script will pass data to. 
### Enter a url, or leave blank. Example: 
### $second_script_url = 'http://www.tigertom.com/cgi-bin/omni/somescript2.cgi';
###
### [IMPORTANT: If you choose to send data to another script, its 
### 'end-page' will be the one the customer sees. THIS IS NOT A SECURE 
### WAY OF PASSING IMPORTANT DATA, as the data may be visible in the URL 
### query_string, in the browser location box. Leave these 
### options blank if you want this script to produce a web-page displaying
### data the customer enters into your form.] 

$second_script_url = '';

### Enter the URL of a final HTML thank-you page that this script 
### will re-direct the customer to, or leave blank i.e. nothing 
### between the apostrophes:
### $thanks_url = 'http://www.tigertom.com/thanks4.htm';

$thanks_url = '';

######################## Email Configuration ###############################

# Email addresses that this form sends to are to be set up as hidden
# text fields in the from (see omni.html), with the exception of the
# following: 

# Email address that the script may send hack alerts etc. to :

$webmaster = 'script@tigertom.com';

########################## Mailing List Configuration ######################

# NEW: This script will try to bulk-email your subscriber database, if
# *any* of the following form fields are sent to it:
# 'message', 'bulk_sender' or 'mail_subject'.

# To stop it, just don't have any of these fields (filled in) in your
# form.

# Password to allow bulk mail-out via this script.
# Tip: The password should be at least 8 characters' long, be composed 
# of both numbers and letters, and both upper and lowercase letters. 
# CHANGE it, and DON'T make it a short, easily-guessed word :

$the_password = 'G00DScr1Pt';

# (Absolute) path to data file to store mailing-list subscriber data.
# Set this if you want to save the form user's email addresses into
# a separate file.  The bulk-mailing feature looks for this file. 
# In this example, the file is not in the same directory as the 
# script:  $subscriber_file = '/user/tigertom/web/html/subscriber.dat'.
# Here, we assume it's in the same directory as the script:

$subscriber_file = 'subscriber.dat';

# What fields are the names and addresses in, in the subscriber database.
# Counting from left to right, which fields are the
# following variables in?
# [NOTE!!! The count starts from 0, not 1 i.e. the first field is field 0, then
# 1,2,3,4,5 etc.]

 
$name_loc = "0";      # The field where the customer/member name is
$addr_loc = "1";      # The field where the customer email address is

# [Example: If the email address was in the fourth field in the database, $addr_loc
# would be equal to "3".] 
# If there are only email addresses in your database, set both scalars to
# the field number of the email address i.e. "0".
#
# If there is a mixture of single addresses and name/address pairs only, do not worry.
# Set the scalars above as if there are both names and addresses only. 
# The script will do the rest.
# 
# If your email addresses are all over the place in your database, 
# you have a problem [grin!].
#
# TIP: You could save yourself a lot of bother if your mailing list database 
# is in the following format:
#
# J. Smith|jsmith@yahoo.com
# Tom Jones|tjones123@hotmail.com
#
# ...or just a single email address on each line.
#
# You could use the find-and-replace function in a good text editor to get rid of any
# irregularities in your database, and insert 'pipes' (|) if need be.
#
# HOWEVER: You can use any flat file delimited database for mass mailing, not just
# the one set up and added to in the script, if the script knows where in each line it can find the name
# and email address of each recipient, and these are in the same column(s) throughout the database

 
############################## Presentation #############################

# The subject of your order-related emails, and title of any pages 
# this script may need to throw up :

$subject = "TigerTom Secure Order - Status";

# (Absolute) path to the page header text (html) of pages this script may need 
# to throw up.  In this example, the file is not in the same directory as the 
# script:  $header = '/user/tigertom/web/html/myheader.txt'.
# Here, we assume it's in the same directory as the script:

$header = 'myheader.txt';

# (Absolute) path to the page footer text (html) of pages this script may 
# need to throw up. In this example, the file is not in the same directory as the 
# script: $header = '/user/tigertom/web/html/myfooter.txt'.
# Here, we assume it's in the same directory as the script:

$footer = 'myfooter.txt';

##########################################################################

################ IMPORTANT: Fields Required By This Script! ###############
# This is a list of the form fields this script needs to operate if you
# want to use all its options i.e. *you can't make up your own*: 
#
# Name, Email, from_name, from_email, Recipient, Subject, Card_number, 
# Card_holder, Card_type, Card_expiry_month, Card_expiry_year, email_zip, 
# subscribe, unsubscribe, password, message*, mail_subject. 
# And ID, if you want to set a cookie.
#
# *'message' is used if you want someone to send a form field with lots
# of text; this script will format it.
#
# These fields are already in the html page 'omni.html', so I suggest
# you use that as your template.
#
############################# Required Fields ############################
# The following fields are are those you require to be entered into 
# your form by the customer. 
# Write the form fields that are required, or leave blank 
# like so i.e. nothing between the brackets:
# @required = ();
# NOTE: You can break lines here, if you break on a comma, as below. 
# Otherwise the script will report an error when you try to run it.
# You would do this to put a lot of variables/fields here, as a long single 
# line looks bad, and might 'wrap'.   

@required = ();

# EXAMPLE:
# @required = ('from_name','from_email','Recipient','Subject','Name','Email',
#               'Address','Card_number','Card_holder','Card_type','Card_expiry_month',
#                'Card_expiry_year');


############################ Form Fields to Print and Save #####################

# NOTE AGAIN: You can break lines here if you break on a comma, as below.  
# Otherwise the script will report an error when you run it.

# Form fields to send via email to you and the customer.  If you have PGP set up
# this will be used in the email to you; if not, the script's own weak encryption
# will be used to encrypt credit-card details ONLY. Credit card details will be 
# erased in the customer's email.

  @secure_print = ('Name','Email','Address','City','State','Zip','Country','Phone',
                 'Card_number','Card_holder','Card_type','Card_expiry_month',
                   'Card_expiry_year');

 # Form fields to save only to your database.
 # It's up to you if you want to save credit card details as plain text 
 # on your server, but this is not secure.  The time, date, referer, customer
 # IP number and affiliate cookie (if any) will be printed first in the 
 # database, then the following fields... 
  
   @insecure_save = ('Name','Email','Address','City','State','Zip',
                   'Country','Phone','Card_number','Card_holder',
              'Card_type','Card_expiry_month', 'Card_expiry_year');
 
 
################# Affiliate Tracking / Remote Subscription ################
# Please read this, it's important:
#
# How you set the next variable depends if you want to use this script to 
# track an affiliate id, and/or unsubscribe people to your mailing list.
#
# It states the maximum length (number of characters) of the 
# query_string (the characters after the ? in a url).
# 
# The query_string allows you to set a cookie if someone clicks on your 
# script URL like this :
# http://www.tigertom.com/cgi-bin/omni/omni.cgi?ID=AFFIL4356 
#
# [You can also set a cookie with the name 'ID' if you include it
# as a hidden form field in your form]
#
# This script can also unsubscribe people from your mailing list by clicking on
# a link like this one :
# http://www.tigertom.com/cgi-bin/omni/omni.cgi?Email=theirname@yahoo.com&action=unsubscribe
#
# The variable below helps to stop people trying to spoof your script from 
# outside your domain.
#
# If the query_string exceeds the character-length set here, an error message will 
# come up in the hacker's browser. NOTE: The length may need to be set longer than 
# this example below, if you were unsubscribing people by their 
# clicking on a URL in an email message, as email addresses can sometimes 
# be quite long*.
#
# NOTE: I've made it so you cannot subscribe email addresses from the query_string;
# this is to discourage crackers trying to submit lots of bogus ones.
# NOTE 2:  Unless you are using the affiliate/cookie or unsubscribe-from-an-email feature, set
# the next scalar to 0.
#

 $legit_length = "70";

#
# A query string can be generated by a form using the method GET, or 
# by clicking on a link, or by typing the url and some data, after 
# the question mark (see above), in a browser.
# Setting this variable limits how much information can be passed to your 
# script by this method. This helps stop hacking attempts.
#
########################### Cookie Setup #################################

# If you want to retrieve or set a cookie without using JavaScript. 
# Using this method is surer, as surfers can turn off JavaScript. 
#
# You can set a cookie with the name-value pair ID=daisy456
# or whatever (you must use the name 'ID'). Set your own browser to 
# 'accept cookies, but notify', and try it out. 
#
# Don't accept the cookie if you want to keep testing this script function. 
#

# When will the cookie expire from the browser :
# The 05 refers to the year 2005.

$expires = "Wednesday, 09-Nov-05 00:00:00 GMT";

# Domain from which cookies can be set and retrieved.
# Set this to your domain (without the www) prepended with a .
# Change the $domain variable below to your main URL. 
# *Don't forget the dot at the start*! 


$domain = ".tigertom.com";

# Directories in your domain which will be able to retrieve cookies 
# (leave this line as it is to set and retrieve in all directories) :

$path = "/";

# Set this next value to 1 if you want to set a cookie during a SSL
# session.  Otherwise leave it as-is.

$secure = 0;

############################ Weak CC Encryption ##############################

# If you haven't got PGP, but you still want credit-card numbers emailed to you,
# use this as a last resort. REPLACE THE LETTERS HERE WITH A SET OF YOUR OWN CHOICE. 
# Use different sets of letters for the card number and the expiry-date.

# Set this next value to 0 if you want the credit-card number and expiry-date emailed
# to you as plain text [that would be stupid, but...!].  
# Set it to 1 if you want the credit-card number and expiry-date weakly
# encrypted [**if you have set up the PGP variables correctly in this script it 
# will use that instead**].
# NOTE: Credit card details will not be sent to the customer in any form.

$weak_encrypt = 1;

###### Swop the CARD NUMBER digits for letters: 
%cc_encrypt = (1=>'R',2=>'d',3=>'k',4=>'L',5=>'Q',6=>'P',7=>'z',8=>'X',9=>'B',0=>'H');

# Decryption - using the *same set of letters* (see above), reverse the swop:
%cc_decrypt = (R=>'1',d=>'2',k=>'3',L=>'4',Q=>'5',P=>'6',z=>'7',X=>'8',B=>'9',H=>'0');

###### Swop the card EXPIRY DATE digits [month, year] for letters:
%date_encrypt = (1=>'P',2=>'Z',3=>'f',4=>'C',5=>'n',6=>'J',7=>'A',8=>'X',9=>'r',0=>'e');

# Decryption - using the *same set of letters*, reverse the swop:
%date_decrypt = (P=>'1',Z=>'2',f=>'3',C=>'4',n=>'5',J=>'6',A=>'7',X=>'8',r=>'9',e=>'0');


##################### SHOPPING CART SET-UP #################################
#
# The follwiing is an array of names of form-field cart items; the full 
# item name, its quantity form-field name, and its price form-field name.
#
# If you have no items to sell, leave the following variable blank, like so
# @shelf = ();
#
# Confused? See the cource code of the HTML form 'omni.html' that came with this
# script.

@shelf = ('item1_desc','item1_qty','item1_price',
          'item2_desc','item2_qty','item2_price',
          'item3_desc','item3_qty','item3_price');


# The symbol of your currency e.g. $ or . 
$currency = '$';

# Shipping cost to be added to cart items sub-total [in dollars and cents]:
$shipping = '14.99';

# Tax to be added to cart items sub-total [as a percentage]. 
# This example is 8%:
$tax = '0.08';

#################### UUENCODED EMAIL ZIP-FILE SETUP ########################

# Your form should have code in it like this :
# <INPUT TYPE=RADIO NAME="email_zip" VALUE="">
# <INPUT TYPE=RADIO NAME="email_zip" VALUE="somefile.zip">
# <INPUT TYPE=RADIO NAME="email_zip" VALUE="otherfile.exe">
# <INPUT TYPE=RADIO NAME="email_zip" VALUE="anyfile.zip">
#
# Using radio buttons and the same NAME means only one file
# can be selected by the customer, and then uuencoded and emailed. 
# NOTE: The script can only handle one file at a time.
#
# (Absolute) path to the directory where you put the file(s) you want 
# uuencoded and emailed (NO trailing forward-slash here)
# WARNING: To stop someone trying to get at files in your main cgi-bin, make sure 
# the files are in a separate sub-directory of their own !!! :
		
$zip_dump = '/user/yourserver/absolute/path_to/cgi-bin/omni/dump';


################################# PGP SETUP ###################################

# This script can use PGP version 2.6.2 only, and possibly version 6. It can't
# use version 5. 
#
# IF YOU HAVEN'T GOT PGP ON YOUR SERVER LEAVE THE FOLLOWING VALUES EMPTY, 
# like this: $pgp_path = "";
#
# The script looks for these values, and may crash if it finds false values 
# and tries to execute them.
#

# Location of the PGP PROGRAM on your server (NO trailing slash here)
# e.g $pgp_path = "/usr/bin/pgp262";
# Oct. 2001: I've left it blank here because my current web-host doesn't 
# have PGP. This is enough to stop the PGP routine kicking-in:

$pgp_path = "";

# Your pgp key user id, i.e. its name :

 $pgp_public_key_user_id = "tigertom";

# Location of your pubring.pgp and ranseed.bin files, in a directory 
# off your cgi-bin :
# The tigerpgp directory and all files inside must be readable by the script.

$pgp_config_files = "./tigerpgp";

# Directory where PGP can create temporary files :
# The tigertemp directory must be write-able by the script

$pgp_temp_file_path = "./tigertemp";

# Do NOT change this next line :

$pgp_options = "-feat +VERBOSE=0";

################################ Security ######################################

# Extra security - this line defines what directories programs 
# can be executed from, on your server, by this script. You may need
# to fiddle with this if your programs are in different directories, 
# like 'opt', but it should be fine :

$ENV{'PATH'} = '/usr/lib:/bin:/usr/bin:/usr/local/bin:/usr/sbin';

############################# ~>> FINAL TASK! <<~ ##########################
#
#
# WEBMASTER: NOW OPEN THE FILE 'omni.cgi', and alter the sub-routine order, 
# if required.  See the instructions there-in.
#
#
############################################################################

# Leave this alone:
1;